<?php

// ------------------------------------------------------------------------- //
//                Geeklog - PHP Content Management System                    //
// ------------------------------------------------------------------------- //
// Based on Download Plugin from:                                            //
// myPHPNUKE Web Portal System - http://myphpnuke.com/                       //
// PHP-NUKE Web Portal System - http://phpnuke.org/                          //
// Thatware - http://thatware.org/                                           // 
// ------------------------------------------------------------------------- //
// Modified and Integrated for Geeklog as File Management Plugin             // 
// By: Blaine Lang  -  Sept 25 2002                                          // 
// blaine@portalparts.com                                                    // 
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //


require_once("../../../lib-common.php");
include_once($_CONF[path_html]."filemgmt/include/header.php");
include_once($_CONF[path_html]."filemgmt/include/xoopstree.php");
include_once($_CONF[path_html]."filemgmt/include/textsanitizer.php");
include_once($_CONF[path_html]."filemgmt/include/errorhandler.php");

$display = '';
if (!SEC_hasRights("filemgmt.edit")) {
    if ($op != "comment") {
        $display .= COM_siteHeader('menu');
        $display .= COM_startBlock(_GL_ERRORNOACCESS);
        $display .= _MD_USER." ".$_USER['username']. " " ._GL_NOUSERACCESS;
        $display .= COM_endBlock();
        $display .= COM_siteFooter();
        echo $display;
        exit;
    } 
}

$myts = new MyTextSanitizer;
$mytree = new XoopsTree($_DB_name,$_FM_TABLES['filemgmt_cat'],"cid","pid");
$eh = new ErrorHandler;

function mydownloads() {
    global $_CONF, $_FM_TABLES;
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $result = DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_brokenlinks']}");
    list($totalbrokendownloads) = DB_fetchARRAY($result);
    if($totalbrokendownloads>0){
        $totalbrokendownloads = "<font color=\"#ff0000\"><b>$totalbrokendownloads</b></font>";
    }
    $result2 = DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE status=0");
    list($totalnewdownloads) = DB_fetchARRAY($result2);
    if($totalnewdownloads > 0){
        $totalnewdownloads = "<font color=\"#ff0000\"><b>$totalnewdownloads</b></font>";
    }
    $display .= "<img src=\"{$_CONF['site_url']}/filemgmt/images/button.gif\">&nbsp&nbsp;<a href=index.php?op=filemgmtConfigAdmin>"._MD_GENERALSET."</a>";
    $display .= "<br><br>";
    $display .= "<img src=\"{$_CONF['site_url']}/filemgmt/images/button.gif\">&nbsp&nbsp;<a href=index.php?op=categoryConfigAdmin>"._MD_ADDMODCATEGORY."</a>";   
    $display .= "<br><br>";
    $display .= "<img src=\"{$_CONF['site_url']}/filemgmt/images/button.gif\">&nbsp&nbsp;<a href=index.php?op=newfileConfigAdmin>"._MD_ADDMODFILENAME."</a>";
    $display .= "<br><br>";
    $display .= "<img src=\"{$_CONF['site_url']}/filemgmt/images/button.gif\">&nbsp&nbsp;<a href=index.php?op=listNewDownloads>"._MD_DLSWAITING." ($totalnewdownloads)</a>";
    $display .= "<br><br>";
    $display .= "<img src=\"{$_CONF['site_url']}/filemgmt/images/button.gif\">&nbsp&nbsp;<a href=index.php?op=listBrokenDownloads>"._MD_BROKENREPORTS." ($totalbrokendownloads)</a>";
    $display .= "<br><br>";
    $result=DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE status > 0");
    list($numrows) = DB_fetchARRAY($result);
    $display .= "<br><br><div align=\"center\">";
    $display .= sprintf(_MD_THEREARE,$numrows);
    $display .= "</div>";
    $display .= CloseTable();
    $display .= "<br>";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
}

function listNewDownloads(){
    global $_CONF, $_TABLES, $_FM_TABLES, $myts, $eh, $mytree, $filemgmt_FileStoreURL,$filemgmt_FileSnapURL;
    // List downloads waiting for validation
    $result = DB_query("SELECT lid, cid, title, url, homepage, version, size, logourl, submitter, comments, platform FROM {$_FM_TABLES['filemgmt_filedetail']} where status=0 ORDER BY date DESC");
    $numrows = DB_numROWS($result);
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $display .= "<h4>"._MD_DLSWAITING."&nbsp;($numrows)</h4><br>";
    if ($numrows>0) {
        while(list($lid, $cid, $title, $url, $homepage, $version, $size, $logourl, $submitter, $comments, $tmpnames) = DB_fetchARRAY($result)) {
            $result2 = DB_query("SELECT description FROM {$_FM_TABLES['filemgmt_filedesc']} WHERE lid=$lid");
            list($description) = DB_fetchARRAY($result2);
            $title = $myts->makeTboxData4Edit($title);
            $url = rawurldecode($myts->makeTboxData4Edit($url));
            $logourl = rawurldecode($myts->makeTboxData4Edit($logourl));
            $homepage = $myts->makeTboxData4Edit($homepage);
            $version = $myts->makeTboxData4Edit($version);
            $size = $myts->makeTboxData4Edit($size);
            $description = $myts->makeTareaData4Edit($description);
            $result3 = DB_query("SELECT username FROM {$_TABLES['users']} WHERE uid=".$submitter."");
            list($sendername) = DB_fetchARRAY($result3);
            $tmpfilenames = explode(";",$tmpnames);
            $tempfileurl = $filemgmt_FileStoreURL . 'tmp/' .$tmpfilenames[0];
            if (isset($tmpfilenames[1]) and $tmpfilenames[1] != '') {
                $tempsnapurl = $filemgmt_FileSnapURL . 'tmp/' .$tmpfilenames[1];
            } else {
                $tempsnapurl = '';
            }
            $display .= "<form action=\"index.php\" method=post>\n";
            $display .= "<table width=\"80%\">";
            $display .= "<tr><td align=\"right\" nowrap>"._MD_SUBMITTER."</td><td>\n";
            $display .= '<a href="'. $_CONF['site_url'] . '/users.php?mode=profile&uid='. $submitter. '">'.$sendername.'</a>';
            $display .= "</td></tr>\n";
            $display .= "<tr><td align=\"right\" nowrap>"._MD_FILETITLE."</td><td>";
            $display .= "<input type=\"text\" name=\"title\" size=\"50\" maxlength=\"100\" value=\"$title\">";
            $display .= "</td></tr><tr><td align=\"right\" nowrap>"._MD_DLFILENAME."</td><td>";
            $display .= "<input type=\"text\" name=\"url\" size=\"50\" maxlength=\"250\" value=\"$url\">";
            $display .= "</td></tr>";
            $display .= "<tr><td align=\"right\" nowrap>"._MD_CATEGORYC."</td><td>";
            $display .= $mytree->makeMySelBox("title", "title", $cid);
            $display .= "</td></tr>\n";
            $display .= "<tr><td align=\"right\" nowrap>"._MD_HOMEPAGEC."</td><td>\n";
            $display .= "<input type=\"text\" name=\"homepage\" size=\"50\" maxlength=\"100\" value=\"$homepage\"></td></tr>\n";
            $display .= "<tr><td align=\"right\">"._MD_VERSIONC."</td><td>\n";
            $display .= "<input type=\"text\" name=\"version\" size=\"10\" maxlength=\"10\" value=\"$version\"></td></tr>\n";
            $display .= "<tr><td align=\"right\">"._MD_FILESIZEC."</td><td>\n";
            $display .= "<input type=\"text\" name=\"size\" size=\"10\" maxlength=\"8\" value=\"$size\">&nbsp;"._MD_BYTES."</td></tr>\n";
            $display .= "<tr><td align=\"right\" valign=\"top\" nowrap>"._MD_DESCRIPTIONC."</td><td>\n";
            $display .= "<textarea name=description cols=\"60\" rows=\"5\">$description</textarea>\n";
            $display .= "</td></tr>\n";
            $display .= "<tr><td align=\"right\" nowrap>"._MD_SHOTIMAGE."</td><td>\n";
            $display .= '<input type="text" name="logourl" size="50" maxlength="250" value="'.$logourl.'">';
            if ($tempsnapurl != '') {
                $display .= '<span style = "padding-left:20px;"><a href="' . $tempsnapurl . '">Preview</a></span>';
            }
            $display .= "</td></tr>\n";
            $display .= "<tr><td></td><td>";
            $display .= "</td></tr><tr><td nowrap align='right'>"._MD_COMMENTOPTION."</td><td>";
            if ($comments) {
                $display .= "<INPUT TYPE=\"RADIO\" NAME=\"commentoption\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
                $display .= "<INPUT TYPE=\"RADIO\" NAME=\"commentoption\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
            } else {
                $display .= "<INPUT TYPE=\"RADIO\" NAME=\"commentoption\" VALUE=\"1\" >&nbsp;" ._MD_YES."&nbsp;</INPUT>";
                $display .= "<INPUT TYPE=\"RADIO\" NAME=\"commentoption\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
            }
            $display .= "</td></tr>\n";
            $display .= "</table>\n";
            $display .= "<br><input type=\"hidden\" name=\"op\" value=\"approve\"></input>";
            $display .= "<input type=\"hidden\" name=\"lid\" value=\"$lid\"></input>";
            $display .=  "<input type=\"submit\" value=\""._MD_APPROVE."\">";

            $display .= '<span style = "padding-left:20px;">Download to preview:&nbsp;<a href="' . $tempfileurl . '">tempfile</a></span>';
            $display .= "</form>\n";
            $display .=  myTextForm("index.php?op=delNewDownload&lid=$lid&url=$url",_MD_DELETE);
            if ($numrows>1) {
               $display .=  "<br><HR>"; 
            } else {
               $display .=  "<br>"; 
            }
        }
    } else {
        $display .=  _MD_NOSUBMITTED;
        $display .= '<span style="padding-left:20px;"><a href="' . $_CONF['site_admin_url'] .'/plugins/filemgmt/index.php">Filemgmt Admin Menu</a></span>';
    }
    $display .= CloseTable();
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
}


function categoryConfigAdmin(){
    global $_CONF, $_FM_TABLES, $myts, $eh, $mytree;
    
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $display .= '<form method=POST enctype="multipart/form-data" action="./index.php">';
    $display .= "<h4>"._MD_ADDMAIN."</h4><br>"._MD_TITLEC."<input type=text name=title size=30 maxlength=50><br>";
    $display .= "<br>". _MD_ADDCATEGORYSNAP;
    $display .= "<br><input type='file' name='uploadfile' size='50' maxlength='200'><br>";
    $display .= "<font size='-2'>". _MD_ADDIMAGENOTE ."</font><br><br>";
    $display .= "<input type=hidden name=cid value=0>\n";
    $display .= "<input type=hidden name=op value=addCat>";
    $display .= "<input type=submit value="._MD_ADD."><br></form>";
    $display .= CloseTable();
    $display .= "<br>";
    // Add a New Sub-Category
    $result=DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_cat']}");
    $numrows = DB_numROWS($result);
    if($numrows > 0) {
        $display .= OpenTable();
        $display .= "<form method=post action=index.php>";
        $display .= "<h4>"._MD_ADDSUB."</h4><br />"._MD_TITLEC."<input type=text name=title size=30 maxlength=50>&nbsp;"._MD_IN."&nbsp;";
         $display .= $mytree->makeMySelBox("title", "title");
        $display .= "<input type=hidden name=op value=addCat><br><br>";
        $display .= "<input type=submit value="._MD_ADD."><br></form>";
        $display .= CloseTable();
        $display .= "<br>";
        // Modify Category
        $display .= OpenTable();
        $display .= "<form method=post action=index.php><h4>"._MD_MODCAT."</h4><br>";
        $display .= _MD_CATEGORYC;
        $display .= $mytree->makeMySelBox("title", "title");
        $display .= "<br><br>\n";
        $display .= "<input type=hidden name=op value=modCat>\n";
        $display .= "<input type=submit value="._MD_MODIFY.">\n";
        $display .= "</form>";
        $display .= CloseTable();
        $display .= "<br>";
    }
    
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
}

function newfileConfigAdmin(){
    global $_CONF, $myts, $eh, $mytree;

    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $display .= "<form method=POST enctype='multipart/form-data' action=index.php>\n";
    $display .= "<h4>"._MD_ADDNEWFILE."</h4><br>\n";
    $display .= "<table width=\"80%\"><tr>\n";
    $display .= "<td align=\"right\">"._MD_FILETITLE."</td><td>";
    $display .= "<input type=text name=title size=50 maxlength=100>";
    $display .= "</td></tr><tr><td align=\"right\" nowrap>File:</td><td>";
    $display .= "<input type=file name=newfile size=50 maxlength=100>";
    $display .= "</td></tr>";
    $display .= "<tr><td align=\"right\" nowrap>"._MD_CATEGORYC."</td><td>";
    $display .= $mytree->makeMySelBox("title", "title");
    $display .= "</td></tr><tr><td></td><td></td></tr>\n";
    $display .= "<tr><td align=\"right\" nowrap>"._MD_HOMEPAGEC."</td><td>\n";
    $display .= "<input type=text name=homepage size=50 maxlength=100></td></tr>\n";
    $display .= "<tr><td align=\"right\">"._MD_VERSIONC."</td><td>\n";
     $display .= "<input type=text name=version size=10 maxlength=10></td></tr>\n";
    $display .= "<tr><td align=\"right\" valign=\"top\" nowrap>"._MD_DESCRIPTIONC."</td><td>\n";
    $display .= "<textarea name=description cols=60 rows=5></textarea>\n";
    $display .= "</td></tr>\n";
    $display .= "<tr><td align=\"right\"nowrap>"._MD_SHOTIMAGE."</td><td>\n";
    $display .= "<input type=\"file\" name=\"newfileshot\" size=\"50\" maxlength=\"60\"></td></tr>\n";
    $display .= "<tr><td align=\"right\"></td><td>";
    $display .= "</td></tr><tr><td align='right'>"._MD_COMMENTOPTION."</td><td>";
    $display .= "<INPUT TYPE=\"RADIO\" NAME=\"commentoption\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
    $display .= "<INPUT TYPE=\"RADIO\" NAME=\"commentoption\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    $display .= "</td></tr>\n";
    $display .= "</table>\n<br>";
    $display .=  "<input type=\"hidden\" name=\"op\" value=\"addDownload\"></input>";
    $display .= "<input type=\"submit\" class=\"button\" value=\""._MD_ADD."\"></input>\n";
    $display .= "</form>";
    $display .= CloseTable();
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;

}

function modDownload() {
    global $_CONF,$_FM_TABLES,$_USER, $HTTP_GET_VARS, $myts, $eh, $mytree,$filemgmt_SnapStore,$filemgmt_FileSnapURL;
    
    $lid = $HTTP_GET_VARS['lid'];
    $result = DB_query("SELECT cid, title, url, homepage, version, size, logourl, comments FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE lid=$lid") or $eh->show("0013");
    $nrows = DB_numROWS($result);
    if ($nrows == 0) {
        redirect_header("index.php",2,_MD_NOMATCH);
          exit();
    }
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $display .= "<h4>"._MD_MODDL."</h4><br>";
    list($cid, $title, $url, $homepage, $version, $size, $logourl,$comments) = DB_fetchARRAY($result);
    $title = $myts->makeTboxData4Edit($title);
    $url = rawurldecode($myts->makeTboxData4Edit($url));
    $homepage = $myts->makeTboxData4Edit($homepage);
    $version = $myts->makeTboxData4Edit($version);
    $size = $myts->makeTboxData4Edit($size);
    $logourl = rawurldecode($myts->makeTboxData4Edit($logourl));
    $result2 = DB_query("SELECT description FROM {$_FM_TABLES['filemgmt_filedesc']} WHERE lid=$lid");
    list($description)=DB_fetchARRAY($result2);
    $description = $myts->makeTareaData4Edit($description);
    $display .= '<table width="100%" border="1" cellspacing="1" cellpadding="5">';
    $display .= '<form method=post enctype="multipart/form-data" action=index.php>';
    $display .= '<tr><td>'._MD_FILEID.'</td><td colspan="2"><b>'.$lid.'</b></td></tr>';
    $display .= '<tr><td>'._MD_FILETITLE.'</td><td colspan="2"><input type="text" name="title" value="'.$title.'" size="50" maxlength="200"></input></td></tr>' .LB;
    $display .= '<tr><td>'._MD_DLFILENAME.'</td><td colspan="2"><input type="text" name="url" value="'.$url.'" size="50" maxlength="200"></input></td></tr>' .LB;
    $display .= '<tr><td width="25%">'._MD_REPLFILENAME.'</td><td colspan="2"><input type="file" name="newfile" size="50" maxlength="200"></input></td></tr>' .LB;
    $display .= '<tr><td>'._MD_HOMEPAGEC.'</td><td colspan="2"><input type="text" name="homepage" value="'.$homepage.'" size="50" maxlength="150"></input></td></tr>' .LB;
    $display .= '<tr><td>'._MD_VERSIONC.'</td><td colspan="2"><input type="text" name="version" value="'.$version.'" size="10" maxlength="10"></input></td></tr>' .LB;
    $display .= '<tr><td>'._MD_FILESIZEC.'</td><td colspan="2"><input type="text" name=size value="'.$size.'" size="10" maxlength="20"></input> '._MD_BYTES.'</td></tr>' .LB;
    $display .= '<tr><td valign="top">'._MD_DESCRIPTIONC.'</td><td colspan="2"><textarea name="description" cols="55" rows="10">'.$description.'</textarea></td></tr>' .LB;
    $display .= '<tr><td>'._MD_CATEGORYC.'</td><td colspan="2">';
    $display .= $mytree->makeMySelBox("title", "title", $cid,0,"cid");
    $display .= '</td></tr>' .LB;

    if (!empty($logourl) AND file_exists($filemgmt_SnapStore.$logourl)) {
        $display .= "<tr><td>"._MD_SHOTIMAGE."</td><td width='5%'><img src='{$_CONF[site_url]}/filemgmt/visit.php?Mode=FileSnaps&url={$logourl}' width='80'></td>" .LB;
        $display .= '<td width="35%"><input type="file" size="40" name="newfileshot"><br><br><input type="checkbox" name=deletesnap>&nbsp;Delete</td></tr>' .LB;
    } else {
        $display .= '<tr><td>'._MD_SHOTIMAGE.'</td>' .LB;
        $display .= '<td colspan="2"><input type="file" size="40" name="newfileshot"></td></tr>' .LB;    
    }

    $display .= '<tr><td>'._MD_COMMENTOPTION.'</td><td colspan="2">';
    if ($comments) {
        $display .= '<INPUT TYPE="RADIO" NAME="commentoption" VALUE="1" CHECKED>&nbsp;'._MD_YES.'&nbsp;</INPUT>';
        $display .= '<INPUT TYPE="RADIO" NAME="commentoption" VALUE="0" >&nbsp;'._MD_NO.'&nbsp;</INPUT>';
    } else {
        $display .= '<INPUT TYPE="RADIO" NAME="commentoption" VALUE="1" >&nbsp;'._MD_YES.'&nbsp;</INPUT>';
        $display .= '<INPUT TYPE="RADIO" NAME="commentoption" VALUE="0" CHECKED>&nbsp;'._MD_NO.'&nbsp;</INPUT>';
    }
    $display .= '</td></tr>' .LB;
    $display .= '<tr><td><input type="hidden" name="lid" value="'.$lid.'"></input>';
    $display .= '<input type="hidden" name="op" value="modDownloadS">';
    $display .= '</table>' .LB;
    $display .= '<p><table width="60%" border="0" cellspacing="1" cellpadding="5"><tr><td>';
    $display .= '<input type="submit" value="'._MD_SUBMIT.'"></form></td>' .LB;
    $display .= '<td>' .LB;
    $display .= myTextForm("index.php?op=delDownload&lid=".$lid."&url=".$url , _MD_DELETE);
    $display .= '</td><td>';
    $display .= myTextForm($_CONF['site_url']."/filemgmt/index.php", _MD_CANCEL);
    $display .= '</td></tr></table>' .LB;
    $display .= '<hr>';

    $result5=DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_votedata']}");
    $totalvotes = DB_fetchARRAY($result5);
    $display .= "<table valign=top width=100%>\n";
    $display .= "<tr><td colspan=7><b>";
    if ($totalvotes = '') 
       $totalvotes = 0;
    $display .= sprintf(_MD_DLRATINGS,$totalvotes);
    $display .= " Total Votes are: ".$totalvotes;
    $display .= "</b></td></tr>\n";
    // Show Registered Users Votes
    $result5=DB_query("SELECT ratingid, ratinguser, rating, ratinghostname, ratingtimestamp FROM {$_FM_TABLES['filemgmt_votedata']} WHERE lid = $lid AND ratinguser != 0 ORDER BY ratingtimestamp DESC");
    $votes = DB_numROWS($result5);
    $display .= "<tr><td colspan=7><br><br><b>";
    $display .= sprintf(_MD_REGUSERVOTES,$votes);
    $display .= "</b><br><br></td></tr>\n";
    $display .= "<tr><td><b>" ._MD_USER."  </b></td><td><b>" ._MD_IP."  </b></td><td><b>" ._MD_RATING."  </b></td><td><b>" ._MD_USERAVG."  </b></td><td><b>" ._MD_TOTALRATE."  </b></td><td><b>" ._MD_DATE."  </b></td><td align=\"center\"><b>" ._MD_DELETE."</b></td></tr>\n";
    if ($votes == 0){
          $display .= "<tr><td align=\"center\" colspan=\"7\">" ._MD_NOREGVOTES."<br></td></tr>\n";
    }
    $x=0;
    $colorswitch="dddddd";
    while(list($ratingid, $ratinguser, $rating, $ratinghostname, $ratingtimestamp)=DB_fetchARRAY($result5)) {
        $formatted_date = formatTimestamp($ratingtimestamp);
        
        //Individual user information
        $result2=DB_query("SELECT rating FROM {$_FM_TABLES['filemgmt_votedata']} WHERE ratinguser = $ratinguser");
        $uservotes = DB_numROWS($result2);
        $useravgrating = 0;
        while(list($rating2) = DB_fetchARRAY($result2)){
             $useravgrating = $useravgrating + $rating2;
        }
        $useravgrating = $useravgrating / $uservotes;
        $useravgrating = number_format($useravgrating, 1);
        $ratinguname = $_USER['username'];
        $display .= "<tr><td bgcolor=\"$colorswitch\">$ratinguname</td><td bgcolor=\"$colorswitch\">$ratinghostname</td><td bgcolor=\"$colorswitch\">$rating</td><td bgcolor=\"$colorswitch\">$useravgrating</td><td bgcolor=\"$colorswitch\">$uservotes</td><td bgcolor=\"$colorswitch\">$formatted_date</td><td bgcolor=\"$colorswitch\" align=\"center\">";
        $display .= myTextForm("index.php?op=delVote&lid=$lid&rid=$ratingid" , "X");
        $display .= "</td></tr>\n";
        $x++;
        if ($colorswitch=="dddddd"){
            $colorswitch="ffffff";
        } else {
            $colorswitch="dddddd";
        }
    }
    // Show Unregistered Users Votes
    $result5=DB_query("SELECT ratingid, rating, ratinghostname, ratingtimestamp FROM {$_FM_TABLES['filemgmt_votedata']} WHERE lid = $lid AND ratinguser = 0 ORDER BY ratingtimestamp DESC");
    $votes = DB_numROWS($result5);
    $display .= "<tr><td colspan=7><b><br><br>";
    $display .= sprintf(_MD_ANONUSERVOTES,$votes);
    $display .= "</b><br><br></td></tr>\n";
    $display .= "<tr><td colspan=2><b>" ._MD_IP."  </b></td><td colspan=3><b>" ._MD_RATING."  </b></td><td><b>" ._MD_DATE."  </b></b></td><td align=\"center\"><b>" ._MD_DELETE."</b></td><br></tr>";
    if ($votes == 0) {
           $display .= "<tr><td colspan=\"7\" align=\"center\">" ._MD_NOUNREGVOTES."<br></td></tr>";
    }
    $x=0;
    $colorswitch="dddddd";
    while(list($ratingid, $rating, $ratinghostname, $ratingtimestamp)=DB_fetchARRAY($result5)) {
           $formatted_date = formatTimestamp($ratingtimestamp);
        $display .= "<td colspan=\"2\" bgcolor=\"$colorswitch\">$ratinghostname</td><td colspan=\"3\" bgcolor=\"$colorswitch\">$rating</td><td bgcolor=\"$colorswitch\">$formatted_date</td><td bgcolor=\"$colorswitch\" align=\"center\">";
        $display .= myTextForm("index.php?op=delVote&lid=$lid&rid=$ratingid" , "X");
        $display .= "</td></tr>";
        $x++;
        if ($colorswitch=="dddddd") {
              $colorswitch="ffffff";
        } else {
           $colorswitch="dddddd";
        }
    }
    $display .= "<tr><td colspan=\"6\">&nbsp;<br></td></tr>\n";
    $display .= "</table>\n";
    $display .= CloseTable();
    $display .= "<br>";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
}

function listBrokenDownloads() {
    global $_CONF,$_TABLES, $_FM_TABLES, $myts, $eh;
    $result = DB_query("SELECT * FROM {$_FM_TABLES['filemgmt_brokenlinks']} ORDER BY reportid");
    $totalbrokendownloads = DB_numROWS($result);
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $display .= "<h4>"._MD_BROKENREPORTS." ($totalbrokendownloads)</h4>";

    if ($totalbrokendownloads==0) {
        $display .= _MD_NOBROKEN;
        $display .= '<span style="padding-left:20px;"><a href="' . $_CONF['site_admin_url'] .'/plugins/filemgmt/index.php">Filemgmt Admin Menu</a></span>';
    } else {
        $display .= '<blockquote>' . _MD_IGNOREDESC . "<br>"._MD_DELETEDESC."</blockquote><br><br>";
        $colorswitch="#dddddd";
        $display .= "<table align=\"center\" width=\"90%\">";
        $display .= "<tr><td><b>"._MD_FILETITLE."</b></td>
                      <td><b>" ._MD_REPORTER."</b></td>
                      <td><b>" ._MD_FILESUBMITTER."</b></td>
                      <td><b>" ._MD_IGNORE."</b></td>
                      <td><b>" ._MD_DELETE."</b></td>
                    </tr>";
       while(list($reportid, $lid, $sender, $ip)=DB_fetchARRAY($result)){
           $result2 = DB_query("SELECT title, url, submitter FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE lid=$lid");
           if ($sender != 0) {
               $result3 = DB_query("SELECT username, email FROM {$_TABLES['users']} WHERE uid=".$sender."");
               list($sendername, $email)=DB_fetchARRAY($result3);
            }
            list($title, $url, $owner)=DB_fetchARRAY($result2);
            $result4 = DB_query("SELECT username, email FROM {$_TABLES['users']} WHERE uid=".$owner."");
            list($ownername, $owneremail)=DB_fetchARRAY($result4);
            $display .= '<tr><td bgcolor='.$colorswitch.'><a href="'.$_CONF['site_url'].'/filemgmt/visit.php?lid='.$lid.'">'.$title.'</a></td>';
            
            if ($email=="") { 
                $display .= "<td bgcolor=$colorswitch>$sendername ($ip)";
            } else {
               $display .= "<td bgcolor=$colorswitch><a href=mailto:$email>$sendername</a> ($ip)";
            }
            $display .= "</td>";
            if ($owneremail=='') {
                $display .= "<td bgcolor=$colorswitch>$ownername";
            } else { 
                $display .= "<td bgcolor=$colorswitch><a href=mailto:$owneremail>$ownername</a>";
            }
            $display .= "</td><td bgcolor='$colorswitch' align='center'>\n";
            $display .= myTextForm("index.php?op=ignoreBrokenDownloads&lid=$lid" , "X");
            $display .= "</td>";
            $display .= "<td bgcolor='$colorswitch' align='center'>\n";
            $display .= myTextForm("index.php?op=delBrokenDownloads&lid=$lid" , "X");
            $display .= "</td></tr>\n";
            if ($colorswitch=="#dddddd") {
                $colorswitch="#ffffff";
            } else {
                $colorswitch="#dddddd";
            }
        }
        $display .= "</table>";
    }
    $display .= CloseTable();
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
}

function delBrokenDownloads() {
    global $_FM_TABLES, $HTTP_GET_VARS, $eh;
    $lid = $HTTP_GET_VARS['lid'];
    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_brokenlinks']} WHERE lid=$lid") or $eh->show("0013");
    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedetail']}  WHERE lid=$lid") or $eh->show("0013");
    redirect_header("index.php?op=listBrokenDownloads",1,_MD_FILEDELETED);
    exit();
}

function ignoreBrokenDownloads() {
    global $_FM_TABLES,$HTTP_GET_VARS, $eh;
    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_brokenlinks']} WHERE lid={$HTTP_GET_VARS['lid']}") or $eh->show("0013");
    redirect_header("index.php?op=listBrokenDownloads",1,_MD_BROKENDELETED);
    exit();
}

function delVote() {
   global $_CONF,$_FM_TABLES,$HTTP_GET_VARS, $eh;
   $rid = $HTTP_GET_VARS['rid'];
   $lid = $HTTP_GET_VARS['lid'];
   //COM_errorLOG("delete vote for lid# ".$lid ." ratingid: ".$rid);
   DB_query("DELETE FROM {$_FM_TABLES['filemgmt_votedata']} WHERE ratingid=$rid") or $eh->show("0013");
   updaterating($lid);
   redirect_header("{$_CONF['site_url']}/filemgmt/index.php",2,_MD_VOTEDELETED);
   exit();
}


function modDownloadS() {

    global $_CONF,$_FM_TABLES,$HTTP_POST_VARS,$HTTP_POST_FILES,$myts,$eh,$filemgmt_SnapStore,$filemgmt_FileStore;
    $cid = $HTTP_POST_VARS["cid"];
    if (($HTTP_POST_VARS["url"]) || ($HTTP_POST_VARS["url"]!="")) {
        $url = rawurlencode($myts->makeTboxData4Save($HTTP_POST_VARS["url"]));
    }

    $currentfile = DB_getITEM($_FM_TABLES['filemgmt_filedetail'], "url", "lid={$HTTP_POST_VARS['lid']}");
    $currentfileFQN = $filemgmt_FileStore . $myts->makeTboxData4Save(rawurldecode($currentfile));
    $newfile = rawurlencode($myts->makeTboxData4Save($HTTP_POST_FILES["newfile"]['name']));
    COM_errorLOG("Currentfilename is:'$currentfile' and new file is:'$newfile'");
    if (($newfile !="" AND $currentfile != $newfile)  OR ($newfile !="" and $currentfile == "")) {
        COM_errorLOG("Download file has changed");
        if (uploadNewFile($HTTP_POST_FILES["newfile"],$filemgmt_FileStore)) {
            if (file_exists($currentfileFQN) && (!is_dir($currentfileFQN))) {
               $err=@unlink ($currentfileFQN);
            }
            $url = rawurlencode($myts->makeTboxData4Save($HTTP_POST_FILES['newfile']['name']));
            DB_query("UPDATE {$_FM_TABLES['filemgmt_filedetail']} SET url='$url' WHERE lid=".$HTTP_POST_VARS['lid']."")  or $eh->show("0013");
       } 
    } 

    $currentsnapfile = DB_getITEM($_FM_TABLES['filemgmt_filedetail'], "logourl", "lid={$HTTP_POST_VARS['lid']}");
    $currentSnapFQN = $filemgmt_SnapStore . $myts->makeTboxData4Save(rawurldecode($currentsnapfile));
    $newsnapfile = rawurlencode($myts->makeTboxData4Save($HTTP_POST_FILES["newfileshot"]['name']));
    //COM_errorLOG("Currentfilename is:'$currentfile' and new file is:'$newfile'");
    if (($newsnapfile !="" AND $currentsnapfile != $newsnapfile)  OR ($newsnapfile !="" and $currentsnapfile == "")) {
        //COM_errorLOG("Snap file has changed");
        if (uploadNewFile($HTTP_POST_FILES["newfileshot"],$filemgmt_SnapStore)) {
            if (file_exists($currentSnapFQN) && (!is_dir($currentSnapFQN))) {
               $err=@unlink ($currentSnapFQN);
            }
            $logourl = rawurlencode($myts->makeTboxData4Save($HTTP_POST_FILES['newfileshot']['name']));
            DB_query("UPDATE {$_FM_TABLES['filemgmt_filedetail']} SET logourl='$logourl' WHERE lid=".$HTTP_POST_VARS['lid']."")  or $eh->show("0013");
       } 
    } elseif(isset($HTTP_POST_VARS['deletesnap'])) {
        if (file_exists($currentSnapFQN) && (!is_dir($currentSnapFQN))) {
            $err=@unlink ($currentSnapFQN);
            DB_query("UPDATE {$_FM_TABLES['filemgmt_filedetail']} SET logourl='' WHERE lid=".$HTTP_POST_VARS['lid']."");
            COM_errorLOG("Delete repository snapfile:$currentSnapFQN.");
        }
    }    
    
    $title = $myts->makeTboxData4Save($HTTP_POST_VARS["title"]);
    $homepage = $myts->makeTboxData4Save($HTTP_POST_VARS["homepage"]);
    $version = $myts->makeTboxData4Save($HTTP_POST_VARS["version"]);
    $size = $myts->makeTboxData4Save($HTTP_POST_VARS["size"]);
    $description = $myts->makeTareaData4Save($HTTP_POST_VARS["description"]);
    $commentoption = $HTTP_POST_VARS["commentoption"];
    DB_query("UPDATE {$_FM_TABLES['filemgmt_filedetail']} SET cid=$cid, title='$title', url='$url', homepage='$homepage', version='$version', size=$size,status=1, date=".time().", comments=$commentoption WHERE lid=".$HTTP_POST_VARS['lid']."")  or $eh->show("0013");
    DB_query("UPDATE {$_FM_TABLES['filemgmt_filedesc']} SET description='$description' WHERE lid=".$HTTP_POST_VARS['lid']."")  or $eh->show("0013");
    redirect_header("{$_CONF['site_url']}/filemgmt/index.php",2,_MD_DBUPDATED);
    exit();
}

function delDownload() {
    global $_FM_TABLES, $_CONF, $HTTP_GET_VARS, $myts, $filemgmt_FileStore, $filemgmt_SnapStore,$eh;
    $lid = $myts->makeTboxData4Save($HTTP_GET_VARS['lid']);
    $name = $myts->makeTboxData4Save(rawurldecode($HTTP_GET_VARS["url"]));
    $tmpurl = rawurlencode($HTTP_GET_VARS['url']);
    $tmpfile  = $filemgmt_FileStore . $name;
    
    $result = DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE url='".$tmpurl."'");
    list($numrows) = DB_fetchARRAY($result);
    $tmpsnap = DB_getItem($_FM_TABLES['filemgmt_filedetail'],'logourl',"lid=$lid");
    $tmpsnap  = $filemgmt_SnapStore . $tmpsnap;

    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE lid=".$HTTP_GET_VARS['lid']."") or $eh->show("0013");
    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedesc']} WHERE lid=".$HTTP_GET_VARS['lid']."") or $eh->show("0013");
    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_votedata']} WHERE lid=".$HTTP_GET_VARS['lid']."") or $eh->show("0013");
    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_brokenlinks']} WHERE lid=".$HTTP_GET_VARS['lid']."") or $eh->show("0013");
    
    // Check for duplicate files of the same filename (actual filename in repository)
    // We don't want to delete actual file if there are more then 1 record linking to it.
    // Site may be allowing more then 1 file listing to duplicate files
    if ($numrows > 1) {
         redirect_header("{$_CONF['site_url']}/filemgmt/index.php",2,_MD_FILENOTDELETED);
         exit();
    } else {
        if ($tmpfile != "" && file_exists($tmpfile) && (!is_dir($tmpfile))) {
            $err=@unlink ($tmpfile);
            //COM_errorLOG("Delete repository file: ".$tmpfile." Return status of unlink is: ".$err);
        }
        if ($tmpsnap != "" && file_exists($tmpsnap) && (!is_dir($tmpsnap))) {
            $err=@unlink ($tmpsnap);
            //COM_errorLOG("Delete repository snapfile: ".$tmpsnap." Return status of unlink is: ".$err);
        }
    }
    redirect_header("{$_CONF['site_url']}/filemgmt/index.php",2,_MD_FILEDELETED);
    exit();
}

function modCat() {
    global $_CONF,$_FM_TABLES, $HTTP_POST_VARS, $myts, $eh, $mytree;
    $cid = $HTTP_POST_VARS["cid"];
    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $display .= "<h4>"._MD_MODCAT."</h4><br>";
    $result=DB_query("SELECT pid, title, imgurl FROM {$_FM_TABLES['filemgmt_cat']} WHERE cid=$cid");
    list($pid,$title,$imgurl) = DB_fetchARRAY($result);
    $title = $myts->makeTboxData4Edit($title);
    $imgurl = rawurldecode($myts->makeTboxData4Edit($imgurl));
    $display .= "<form action=index.php method=post>"._MD_TITLEC."<input type=text name=title value=\"$title\" size=51 maxlength=50><br><br>"._MD_IMGURLMAIN."<br><input type=text name=imgurl value=\"$imgurl\" size=50 maxlength=100><br />
    <br />"._MD_PARENT."&nbsp;";
    $display .= $mytree->makeMySelBox("title", "title", $pid, 1, "pid");
    $display .= '<br>';
    $display .= "<input type='hidden' name='cid' value='$cid'>
        <input type=hidden name=op value=modCatS><br>
        <input type=submit value=\""._MD_SAVE."\">
        <input type=button value="._MD_DELETE." onClick=\"location='index.php?pid=$pid&cid=$cid&op=delCat'\">";
    $display .= "&nbsp;<input type=button value="._MD_CANCEL." onclick=\"javascript:history.go(-1)\">";
    $display .= "</form>";
    $display .= CloseTable();
    $display .= "<br>";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
}


function delNewDownload() {
    global $_FM_TABLES, $HTTP_GET_VARS, $filemgmt_FileStore, $filemgmt_SnapStore, $myts, $eh;
    $lid = $HTTP_GET_VARS['lid'];
    $tmpnames = explode(";",DB_getItem($_FM_TABLES['filemgmt_filedetail'],'platform',"lid = $lid"));
    $tmpfilename = $tmpnames[0];
    $tmpshotname = $tmpnames[1];
    $tmpfilename = $filemgmt_FileStore ."tmp/" . $tmpfilename;    
    $tmpshotname = $filemgmt_SnapStore ."tmp/" . $tmpshotname;

    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE lid='$lid'") or $eh->show("0013");
    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedesc']} WHERE lid='$lid'") or $eh->show("0013");
    if ($tmpfilename !="" && file_exists($tmpfilename) && (!is_dir($tmpfilename))) {
        $err=@unlink ($tmpfilename);
        //COM_errorLOG("Delete submitted file: ".$tmpfilename." Return status of unlink is: ".$err);
    }
    if ($tmpshotname !="" && file_exists($tmpshotname) && (!is_dir($tmpshotename))) {
        $err=@unlink ($tmpshotname);
        //COM_errorLOG("Delete submitted snapshot: ".$tmpshotname." Return status of unlink is: ".$err);
    }
    redirect_header("index.php?op=listNewDownloads",1,_MD_FILEDELETED);
    exit();
}



function modCatS() {
    global $_CONF,$_FM_TABLES, $HTTP_POST_VARS, $myts, $eh;
    $cid =  $HTTP_POST_VARS['cid'];
    $sid =  $HTTP_POST_VARS['pid'];
    $title =  $myts->makeTboxData4Save($HTTP_POST_VARS['title']);
    $title = str_replace('/','&#47',$title);
    if (($HTTP_POST_VARS["imgurl"]) || ($HTTP_POST_VARS["imgurl"]!="")) {
        $imgurl = $myts->makeTboxData4Save($HTTP_POST_VARS["imgurl"]);
    }
    DB_query("UPDATE {$_FM_TABLES['filemgmt_cat']} SET title='$title', imgurl='$imgurl', pid='$sid' where cid=$cid") or $eh->show("0013");
    redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php",2,_MD_DBUPDATED);
    exit();
}

function delCat() {
        global $_CONF,$_FM_TABLES, $HTTP_GET_VARS, $eh, $mytree, $filemgmt_FileStore, $filemgmt_SnapStore;
        $cid =  $HTTP_GET_VARS['cid'];
        if($HTTP_GET_VARS['ok']){
            $ok =  $HTTP_GET_VARS['ok'];
        }
        if($ok==1) {
            //get all subcategories under the specified category
            $arr=$mytree->getAllChildId($cid);
            for($i=0;$i<sizeof($arr);$i++){
                //get all downloads in each subcategory
                $result=DB_query("SELECT lid,url,logourl FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE cid={$arr[$i]}") or $eh->show("0013");
                //now for each download, delete the text data and votes associated with the download
                while(list($lid,$url,$logourl)= DB_fetchARRAY($result)){
                    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedesc']} WHERE lid=$lid")    or $eh->show("0013");
                    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_votedata']} WHERE lid=$lid")    or $eh->show("0013");
                    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE lid=$lid")  or $eh->show("0013");
                    DB_query("DELETE FROM {$_FM_TABLES['filemgmt_brokenlinks']} WHERE lid=$lid")  or $ef->show("0013");
                    $name = rawurldecode($url);
                    $fullname  = $filemgmt_FileStore . $name;
                    if ($fullname !="" && file_exists($fullname) && (!is_dir($fullname))) {
                        $err=@unlink($fullname);
                        //COM_errorLOG("Delete Category - removed File: ".$fullname." Return status of unlink is: ".$err);
                    }
                    $name = rawurldecode($logourl);
                    $fullname  = $filemgmt_SnapStore . $name;
                    if ($fullname !="" && file_exists($fullname) && (!is_dir($fullname))) {
                        $err=@unlink($fullname);
                        //COM_errorLOG("Delete Category - removed Snap: ".$fullname." Return status of unlink is: ".$err);
                    }
                }

                //all downloads for each subcategory is deleted, now delete the subcategory data
                DB_query("DELETE FROM {$_FM_TABLES['filemgmt_cat']} WHERE cid={$arr[$i]}") or $eh->show("0013");
            }
            //all subcategory and associated data are deleted, now delete category data and its associated data
            
            $result=DB_query("SELECT lid,url,logourl FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE cid=$cid") or $eh->show("0013");
            while(list($lid,$url,$logourl)= DB_fetchARRAY($result)){
               DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE lid=$lid") or $eh->show("0013");
               DB_query("DELETE FROM {$_FM_TABLES['filemgmt_filedesc']} WHERE lid=$lid") or $eh->show("0013");
               DB_query("DELETE FROM {$_FM_TABLES['filemgmt_brokenlinks']} WHERE lid=$lid") or $eh->show("0013");
               
               $name = rawurldecode($url);
                    $fullname  = $filemgmt_FileStore . $name;
                    if ($fullname !="" && file_exists($fullname) && (!is_dir($fullname))) {
                        $err=@unlink($fullname);
                        //COM_errorLOG("Delete Category - removed File: ".$fullname." Return status of unlink is: ".$err);

                    }
                    $name = rawurldecode($logourl);
                    $fullname  = $filemgmt_SnapStore . $name;
                    if ($fullname !="" && file_exists($fullname) && (!is_dir($fullname))) {
                        $err=@unlink($fullname);
                        //COM_errorLOG("Delete Category - removed Snap: ".$fullname." Return status of unlink is: ".$err);

                    }
           }
           DB_query("DELETE FROM {$_FM_TABLES['filemgmt_cat']} WHERE cid={$cid}") or $eh->show("0013");
           redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php",2,_MD_CATDELETED);
           exit();
    } else {
        $display = COM_siteHeader('menu');
        $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
        $display .= OpenTable();
        $display .= "<center>";
        $display .= "<h4><font color=\"#ff0000\">";
        $display .= _MD_WARNING."</font></h4><br>";
        $display .= "<table><tr><td>\n";
        $display .= myTextForm("index.php?op=delCat&cid=$cid&ok=1",_MD_YES);
        $display .= "</td><td>\n";
        $display .= myTextForm("index.php", _MD_NO);
        $display .= "</td></tr></table>\n";
        $display .=    CloseTable();
        $display .= COM_endBlock();
        $display .= COM_siteFooter();
        echo $display;
    }
}

function addCat() {
        global $_CONF, $_FM_TABLES, $filemgmt_SnapCat,$filemgmt_SnapCatURL;
        global $HTTP_POST_VARS, $HTTP_POST_FILES, $myts, $eh;

        $Update_category = false;
        $pid = $HTTP_POST_VARS["cid"];
        $title = $HTTP_POST_VARS["title"];
        $title = str_replace('/','&#47',$title);
        //COM_errorLOG("Title is ". $title);
        $file_cat = $HTTP_POST_VARS["uploadfile"];
        if (($HTTP_POST_VARS["imgurl"]) || ($HTTP_POST_VARS["imgurl"]!="")) {
               $imgurl = $myts->makeTboxData4Save($HTTP_POST_VARS["imgurl"]);
               $Update_category = true;
        } elseif ($HTTP_POST_FILES["uploadfile"]["name"]!="") {   
                //echo "POST_FILES name is " . $HTTP_POST_FILES["uploadfile"]["name"] .".<br>";
                $name = $HTTP_POST_FILES["uploadfile"]['name'];        // this is the real name of your file
                $tmp  = $HTTP_POST_FILES["uploadfile"]['tmp_name'];    // temporary name of file in temporary directory on server
                  $imgurl = rawurlencode($myts->makeTboxData4Save($name));    
                //COM_errorLOG("Upload filename is ".$name .", tmp dir is: ".$tmp .", Destination  is: ".$filemgmt_SnapCat);
                if (is_uploaded_file ($tmp)) {                       // is this temporary file really uploaded?
                       if(!file_exists($filemgmt_SnapCat.$name)) {       // Check to see the file already exists
                        $returnMove = move_uploaded_file($tmp, $filemgmt_SnapCat.$name);    // move temporary file to your upload directory
                        if (!$returnMove) {
                            //COM_errorLOG(_MD_ERRUPLOAD . " - Error#: " .$returnMove);
                            $error = 1;
                        } else 
                            $Update_category = true;
                    } else { 
                        //COM_errorLOG("Filemgmt - Create Category, Snap aleady exists: ". $filemgmt_SnapCat.$name);
                        $Update_category = true;
                    }    
                }
            } elseif ($title !="") {         // Adding a sub category
               //COM_errorLOG("add subcategory for ". $title ." PID= ". $pid . " CID = ". $cid);
               $Update_category = true;
            }
        if (($Update_category) && ($title !="")) {
            $title = $myts->makeTboxData4Save($title);
            //COM_errorLOG("filemgmt: Category update");
            DB_query("INSERT INTO {$_FM_TABLES['filemgmt_cat']} (pid, title, imgurl) VALUES ($pid, '$title', '$imgurl')") or $eh->show("0013");
        }
        redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php",2,_MD_NEWCATADDED);
        exit();
}

function addDownload() {
    global $_CONF, $_USER,$_FM_TABLES, $filemgmt_FileStoreURL,$filemgmt_FileSnapURL, $filemgmt_FileStore,$filemgmt_SnapStore;
    global $HTTP_POST_VARS, $HTTP_POST_FILES, $myts, $eh;
         
    $filename = $myts->makeTboxData4Save($HTTP_POST_FILES["newfile"]['name']);
    $url = $myts->makeTboxData4Save(rawurlencode($filename)); 
    $snapfilename = $myts->makeTboxData4Save($HTTP_POST_FILES["newfileshot"]['name']);
    $logourl = $myts->makeTboxData4Save(rawurlencode($snapfilename)); 
    $title = $myts->makeTboxData4Save($HTTP_POST_VARS["title"]);
    $homepage = $myts->makeTboxData4Save($HTTP_POST_VARS["homepage"]);
    $version = $myts->makeTboxData4Save($HTTP_POST_VARS["version"]);
    $description = $myts->makeTareaData4Save($HTTP_POST_VARS["description"]);
    $commentoption = $HTTP_POST_VARS["commentoption"];
    $submitter = $_USER['uid'];
    $size = $myts->makeTboxData4Save(intval($HTTP_POST_FILES["newfile"]["size"]));
    $result = DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE url='$url'");
    list($numrows) = DB_fetchARRAY($result);
    $errormsg = "";

    // Check if Title blank
    if ($title=="") {
        $eh->show("1104");
     }
    // Check if Description blank
    if ($description=="") {
           $eh->show("1105");
     }
     // Check if a file was uploaded
    if ($HTTP_POST_FILES['newfile']['size'] == 0) {
        $eh->show("1017");
    }    
    
    if ( !empty($HTTP_POST_VARS['cid']) ) {
           $cid = $HTTP_POST_VARS['cid'];
    } else {
        $cid = 0;
    }

    if (uploadNewFile($HTTP_POST_FILES["newfile"],$filemgmt_FileStore)) {
        $AddNewFile = true;
    }    
    if (uploadNewFile($HTTP_POST_FILES["newfileshot"],$filemgmt_SnapStore)) {
        $AddNewFile = true;
    }    
    
    if ($AddNewFile){
        DB_query("INSERT INTO {$_FM_TABLES['filemgmt_filedetail']} (cid, title, url, homepage, version, size, logourl, submitter, status, date, hits, rating, votes, comments) VALUES ($cid, '$title', '$url', '$homepage', '$version', $size, '$logourl', $submitter, 1, ".time().", 0, 0, 0," .$commentoption .")") or $eh->show("0013");
        $newid = DB_insertID();
        DB_query("INSERT INTO {$_FM_TABLES['filemgmt_filedesc']} (lid, description) VALUES ($newid, '$description')") or $eh->show("0013");
        if ($duplicatefile) {
            redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php",2,_MD_NEWDLADDED_DUPFILE);
        } elseif ($duplicatesnap) {
            redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php",2,_MD_NEWDLADDED_DUPSNAP);
        } else {
            redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php",2,_MD_NEWDLADDED);
        }
        exit();
        
    } else {
        redirect_header("index.php",2,_MD_ERRUPLOAD."");
        exit();
    }

}


function approve(){
    global $_FM_TABLES, $_TABLES, $_CONF, $HTTP_POST_VARS, $myts, $eh, $filemgmt_FileStore, $filemgmt_SnapStore, $filemgmt_Emailoption,$filemgmtFilePermissions;
    $lid = $HTTP_POST_VARS['lid'];
    $title = $HTTP_POST_VARS['title'];
    $cid = $HTTP_POST_VARS['cid'];
    if ( empty($cid) ) {
        $cid = 0; 
    }
    $homepage = $HTTP_POST_VARS['homepage'];
    $version = $HTTP_POST_VARS['version'];
    $size = $HTTP_POST_VARS['size'];
    $description = $HTTP_POST_VARS['description'];
    if (($HTTP_POST_VARS["url"]) || ($HTTP_POST_VARS["url"]!="")) {
        $name = $myts->makeTboxData4Save($HTTP_POST_VARS["url"]);   
        $url = rawurlencode($name);
    }
    if (($HTTP_POST_VARS["logourl"]) || ($HTTP_POST_VARS["logourl"]!="")) {
        $shotname = $myts->makeTboxData4Save($HTTP_POST_VARS["logourl"]); 
        $logourl = $myts->makeTboxData4Save(rawurlencode($HTTP_POST_VARS["logourl"]));
    }

    $result = DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE url='$url' and status=1");
    list($numrows) = DB_fetchARRAY($result);
    
    // Comment out this check if you want to allow duplicate filelistings for same file in the repository
    // Check for duplicate files of the same filename (actual filename in repository)
    if ($numrows>0) {
        $eh->show("1108");
    }

    $title = $myts->makeTboxData4Save($title);
    $homepage = $myts->makeTboxData4Save($homepage);
    $version = $myts->makeTboxData4Save($HTTP_POST_VARS["version"]);
    $size = $myts->makeTboxData4Save($HTTP_POST_VARS["size"]);
    $description = $myts->makeTareaData4Save($description);
    $commentoption = $HTTP_POST_VARS["commentoption"];
    
    // Move file from tmp directory under the document filestore to the main file directory
    // Now to extract the temporary names for both the file and optional thumbnail. I've used th platform field which I'm not using now for anything.
    $tmpnames = explode(";",DB_getItem($_FM_TABLES['filemgmt_filedetail'],'platform',"lid = $lid"));
    $tmpfilename = $tmpnames[0];
    $tmpshotname = $tmpnames[1];
    $tmp = $filemgmt_FileStore ."tmp/" . $tmpfilename;
    if (file_exists($tmp) && (!is_dir($tmp))) {                      // if this temporary file was really uploaded?
        $newfile = $filemgmt_FileStore .$name;
        COM_errorLOG("File move from ".$tmp. " to " .$newfile );
        $rename = @rename ($tmp,$newfile);
        COM_errorLOG("Results of rename is: ".$rename);
        $chown = @chmod ($newfile,$filemgmtFilePermissions);
        if (!file_exists($newfile )) {
            COM_errorLOG("Filemgmt upload approve error: New file does not exist after move of tmp file: '".$newfile ."'");
            $AddNewFile = false;    // Set false again - in case it was set true above for actual file
            $eh->show("1101");
        } else {
           $AddNewFile = true;
        }
    } else {
        COM_errorLOG("Filemgmt upload approve error: Temporary file does not exist: '".$tmp ."'");
        $eh->show("1101");
    }  

    if ($tmpshotname !="") {
        $tmp  = $filemgmt_SnapStore ."tmp/" . $tmpshotname;
        if (file_exists($tmp) && (!is_dir($tmp))) {                // if this temporary Thumbnail was really uploaded?
            $newfile = $filemgmt_SnapStore .$shotname;
            $rename = @rename ($tmp,$newfile);
            $chown = @chmod ($newfile,$filemgmtFilePermissions);
            if (!file_exists($newfile )) {
                COM_errorLOG("Filemgmt upload approve error: New file does not exist after move of tmp file: '".$newfile ."'");
                $AddNewFile = false;    // Set false again - in case it was set true above for actual file
                $eh->show("1101");
            }
        } else {
            COM_errorLOG("Filemgmt upload approve error: Temporary file does not exist: '".$tmp ."'");
            $eh->show("1101");
        }  
    }
    if ($AddNewFile) {
        DB_query("UPDATE {$_FM_TABLES['filemgmt_filedetail']} SET cid=$cid, title='$title', url='$url', homepage='$homepage', version='$version', size=$size, logourl='$logourl', status=1, date=".time() .", comments=$commentoption where lid=".$lid) or $eh->show("0013");
        DB_query("UPDATE {$_FM_TABLES['filemgmt_filedesc']} SET description='$description' where lid='$lid'") or $eh->show("0013");

        // Send a email to submitter notifying them that file was approved
        if ($filemgmt_Emailoption) {
            $result = DB_query("SELECT username, email FROM {$_TABLES['users']} a, {$_FM_TABLES['filemgmt_filedetail']} b WHERE a.uid=b.submitter and b.lid = $lid");
            list ($submitter_name, $emailaddress) = DB_fetchARRAY($result);    
            $mailtext  = sprintf(_MD_HELLO,$submitter_name);
            $mailtext .= ",\n\n" ._MD_WEAPPROVED. " " .$title. " \n" ._MD_THANKSSUBMIT. "\n\n";
            $mailtext .= "{$_CONF["site_name"]}\n";
            $mailtext .= "{$_CONF['site_url']}\n";
            //COM_errorLOG("email: ".$emailaddress.", text: ".$mailtext);
            if (function_exists(COM_mail) ) {
                COM_mail($emailaddress,_MD_APPROVED,$mailtext);
            } else {
                mail($emailaddress ,"{$_CONF["site_name"]}: " . _MD_UPLOADAPPROVED ,$mailtext, "From: {$_CONF["site_name"]} <{$_CONF["site_mail"]}>\nReturn-Path: <{$_CONF["site_mail"]}>\nX-Mailer: GeekLog $VERSION" );
            }
         }
    }
    redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php?op=listNewDownloads",2,_MD_NEWDLADDED);
    exit();
}


function filemgmtConfigAdmin() {
    global $filemgmt_AllUserAccess, $filemgmt_AllRegisteredUserAccess, $filemgmt_AllowUserUploads;
    global $mydownloads_perpage, $mydownloads_popular, $mydownloads_newdownloads, $mydownloads_top, $mydownloads_trimdesc, $mydownloads_dlreport,$mydownloads_whatsnew;
    global $mydownloads_selectpriv, $mydownloads_uploadselect, $mydownloads_publicpriv, $mydownloads_uploadpublic;
    global $mydownloads_sresults, $mydownloads_anonadddownloadlock, $mydownloads_useshots, $mydownloads_allow_bbcode, $mydownloads_allow_smilies, $mydownloads_shotwidth;
    global $filemgmt_Emailoption, $filemgmt_FileStoreURL,$filemgmt_FileSnapURL, $filemgmt_FileStore, $filemgmt_SnapStore, $filemgmt_SnapCat, $filemgmt_SnapCatURL;

    $display = COM_siteHeader('menu');
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= OpenTable();
    $display .= "<h4>" . _MD_GENERALSET . "</h4><br>";
    $display .= "<form action=\"index.php\" method=\"post\">";
    $display .= "<table width=100% border=0><tr><td nowrap>"._MD_DLSPERPAGE."</td><td width=100%>
        <select name=xmydownloads_perpage>
        <option value=$mydownloads_perpage selected>$mydownloads_perpage</option>
        <option value=5>5</option>
        <option value=10>10</option>
        <option value=15>15</option>
        <option value=20>20</option>
        <option value=25>25</option>
        <option value=30>30</option>
        <option value=50>50</option>
        </select>
        </td></tr><tr><td nowrap>
        "._MD_HITSPOP."</td><td>
        <select name=xmydownloads_popular>
        <option value=$mydownloads_popular selected>$mydownloads_popular</option>
        <option value=5>5</option>
        <option value=10>10</option>
        <option value=20>20</option>
        <option value=50>50</option>
        <option value=100>100</option>
        <option value=500>500</option>
        <option value=1000>1000</option>
        </select>
        </td></tr><tr><td nowrap>
        "._MD_DLSNEW."</td><td>
        <select name=xmydownloads_newdownloads>
        <option value=$mydownloads_newdownloads selected>$mydownloads_newdownloads</option>
        <option value=10>10</option>
        <option value=15>15</option>
        <option value=20>20</option>
        <option value=25>25</option>
        <option value=30>30</option>
        <option value=50>50</option>
       </select><BR>";
    $display .= "</td></tr><tr><td nowrap><BR>" . _MD_DLREPORT . " </td><td>";
    if ($mydownloads_dlreport==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_dlreport\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_dlreport\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_dlreport\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_dlreport\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    $display .= "</td></tr><tr><td nowrap>" . _MD_TRIMDESC . " </td><td>";
    if ($mydownloads_trimdesc==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_trimdesc\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_trimdesc\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_trimdesc\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_trimdesc\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    $display .= "</td></tr><tr><td nowrap>" . _MD_WHATSNEWDESC . " </td><td>";
    if ($mydownloads_whatsnew==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_whatsnew\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_whatsnew\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_whatsnew\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_whatsnew\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    $display .= "</td></tr><tr><td colspan=2><HR>";
      $display .= "</td></tr><tr><td nowrap>" . _MD_SELECTPRIV . " </td><td>";
    if ($mydownloads_selectpriv==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_selectpriv\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_selectpriv\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_selectpriv\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_selectpriv\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    $display .= "</td></tr><tr><td nowrap>" . _MD_UPLOADSELECT . " </td><td>";
    if ($mydownloads_uploadselect==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadselect\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadselect\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadselect\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadselect\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
      $display .= "</td></tr><tr><td nowrap>" . _MD_ACCESSPRIV . " </td><td>";
    if ($mydownloads_publicpriv==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_publicpriv\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_publicpriv\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_publicpriv\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_publicpriv\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    $display .= "</td></tr><tr><td nowrap>" . _MD_UPLOADPUBLIC . " </td><td>";
    if ($mydownloads_uploadpublic==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadpublic\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadpublic\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadpublic\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_uploadpublic\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    $display .= "</td></tr><tr><td colspan=2><HR>";
    $display .= "</td></tr><tr><td nowrap>" . _MD_USESHOTS . " </td><td>";
    if ($mydownloads_useshots==1) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_useshots\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_useshots\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_useshots\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"xmydownloads_useshots\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    $display .= "</td></tr>";
    $display .= "<tr><td nowrap>" . _MD_IMGWIDTH . " </td><td>";
    if($mydownloads_shotwidth!=""){
       $display .= "<INPUT TYPE=\"text\" size=\"10\" NAME=\"xmydownloads_shotwidth\" VALUE=\"$mydownloads_shotwidth\"></INPUT>";
    }else{
       $display .= "<INPUT TYPE=\"text\" size=\"10\" NAME=\"xmydownloads_shotwidth\" VALUE=\"140\"></INPUT>";
    }
    
    $display .= "</td></tr><tr><td nowrap>"._MD_EMAILOPTION."</td><td>";
    if ($filemgmt_Emailoption == true) {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"my_emailoption\" VALUE=\"1\" CHECKED>&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"my_emailoption\" VALUE=\"0\" >&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    } else {
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"my_emailoption\" VALUE=\"1\">&nbsp;" ._MD_YES."&nbsp;</INPUT>";
        $display .= "<INPUT TYPE=\"RADIO\" NAME=\"my_emailoption\" VALUE=\"0\" CHECKED>&nbsp;" ._MD_NO."&nbsp;</INPUT>";
    }
    
    $display .= "</td></tr><tr><td nowrap>Directory to store files: </td><td>";
    $display .= "<INPUT TYPE='text' size='50' maxlength='150' NAME='my_filestore' VALUE='$filemgmt_FileStore'></INPUT>";
    $display .= "</td></tr><tr><td nowrap>Directory to store file thumbnails: </td><td>";
    $display .= "<INPUT TYPE='text' size='50' maxlength='150' NAME='my_snapstore' VALUE='$filemgmt_SnapStore'></INPUT>";
    $display .= "</td></tr><tr><td nowrap>Directory to store category thumbnails: </td><td>";
    $display .= "<INPUT TYPE='text' size='50' maxlength='150' NAME='my_snapcat' VALUE='$filemgmt_SnapCat'></INPUT>";
    $display .= "</td></tr><tr><td nowrap>URL to files: </td><td>";
    $display .= "<INPUT TYPE='text' size='50' maxlength='150' NAME='my_filestoreurl' VALUE='$filemgmt_FileStoreURL'></INPUT>";
    $display .= "</td></tr><tr><td nowrap>URL to file thumbnails: </td><td>";
    $display .= "<INPUT TYPE='text' size='50' maxlength='150' NAME='my_filesnapurl' VALUE='$filemgmt_FileSnapURL'></INPUT>";
    $display .= "</td></tr><tr><td nowrap>URL to category thumbnails: </td><td>";
    $display .= "<INPUT TYPE='text' size='50' maxlength='150' NAME='my_snapcaturl' VALUE='$filemgmt_SnapCatURL'></INPUT>";
    $display .= "</td></tr>";
    $display .= "<tr><td>&nbsp;</td></tr>";
    $display .= "</table>";
    $display .= "<input type=\"hidden\" name=\"op\" value=\"filemgmtConfigChange\">";
    $display .= "<input type=\"submit\" value=\""._MD_SAVE."\">";
    $display .= "&nbsp;<input type=\"button\" value=\""._MD_CANCEL."\" onclick=\"javascript:history.go(-1)\">";
    $display .= "</form>";
    $display .= CloseTable();
    $display .= "<br>";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
}

function filemgmtConfigChange() {
        global $HTTP_POST_VARS, $_TABLES, $_CONF;
        global $mydownloads_selectpriv, $mydownloads_uploadselect, $mydownloads_publicpriv, $mydownloads_uploadpublic;
        
        $configfile                 = $_CONF['path'] . 'plugins/filemgmt/filemgmt.php';
        $xmydownloads_popular       = $HTTP_POST_VARS['xmydownloads_popular'];
        $xmydownloads_newdownloads  = $HTTP_POST_VARS['xmydownloads_newdownloads'];
        $xmydownloads_perpage       = $HTTP_POST_VARS['xmydownloads_perpage'];
        $xmydownloads_dlreport      = $HTTP_POST_VARS['xmydownloads_dlreport'];
        $xmydownloads_trimdesc      = $HTTP_POST_VARS['xmydownloads_trimdesc'];
        $xmydownloads_selectpriv    = $HTTP_POST_VARS['xmydownloads_selectpriv'];
        $xmydownloads_publicpriv    = $HTTP_POST_VARS['xmydownloads_publicpriv'];
        $xmydownloads_uploadselect  = $HTTP_POST_VARS['xmydownloads_uploadselect'];
        $xmydownloads_uploadpublic  = $HTTP_POST_VARS['xmydownloads_uploadpublic'];
        $xmydownloads_useshots      = $HTTP_POST_VARS['xmydownloads_useshots'];
        $xmydownloads_shotwidth     = $HTTP_POST_VARS['xmydownloads_shotwidth'];
        $xmydownloads_whatsnew      = $HTTP_POST_VARS['xmydownloads_whatsnew'];
        $my_emailoption             = $HTTP_POST_VARS['my_emailoption'];
        $my_filestoreurl            = $HTTP_POST_VARS['my_filestoreurl'];
        $my_filesnapurl             = $HTTP_POST_VARS['my_filesnapurl'];
        $my_snapcaturl              = $HTTP_POST_VARS['my_snapcaturl'];
        $my_filestore               = $HTTP_POST_VARS['my_filestore'];
        $my_snapstore               = $HTTP_POST_VARS['my_snapstore'];
        $my_snapcat                 = $HTTP_POST_VARS['my_snapcat'];
        
        
        // Check to see if Access Priv or Upload priv have changed
        // Will need to update the GL access table if they have
        
        $feature1_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'filemgmt.user'");
        $feature2_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'filemgmt.upload'");
        
        if ($xmydownloads_selectpriv != $mydownloads_selectpriv ) {
            // Note: assuming "Logged-in Users" group is 13 - always has been
            $result = DB_query("SELECT COUNT(*) FROM {$_TABLES['access']} WHERE acc_ft_id = $feature1_id AND acc_grp_id = 13");
            list($nrows) = DB_fetchArray($result);
            if ($xmydownloads_selectpriv == 1 && $nrows == 0) {   // Enable and there is no record now
                COM_errorLog('Granting Logged-In users access to filemgmt.user feature',1);
                DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feature1_id, 13)");
            } elseif ($xmydownloads_selectpriv == 0 && $nrows == 1) {  // Disable and there is a record
                COM_errorLog('Removing Logged-In users access with filemgmt.user feature',1);
                DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_grp_id = 13 AND acc_ft_id = $feature1_id");
            }
        }
        if ($xmydownloads_publicpriv != $mydownloads_publicpriv ) {
            $result = DB_query("SELECT COUNT(*) FROM {$_TABLES['access']} WHERE acc_ft_id = $feature1_id AND acc_grp_id = 2");
            list($nrows) = DB_fetchArray($result);
            if ($xmydownloads_publicpriv == 1 && $nrows == 0) {   // Enable and there is no record now
                COM_errorLog('Granting anonymous access to filemgmt.user feature',1);
                DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feature1_id, 2)");
            } elseif ($xmydownloads_publicpriv == 0 && $nrows == 1) {  // Disable and there is a record
                COM_errorLog('Removing anonymous access with filemgmt.user feature',1);
                DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_grp_id = 2 AND acc_ft_id = $feature1_id");
            }
        }        
        if ($xmydownloads_uploadselect != $mydownloads_uploadselect ) {
            // Note: assuming "Logged-in Users" group is 13 - always has been
            $result = DB_query("SELECT COUNT(*) FROM {$_TABLES['access']} WHERE acc_ft_id = $feature2_id AND acc_grp_id = 13");
            list($nrows) = DB_fetchArray($result);
            if ($xmydownloads_uploadselect == 1 && $nrows == 0) {   // Enable and there is no record now
                COM_errorLog('Granting Logged-In users upload privilage to filemgmt.user feature',1);
                DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feature2_id, 13)");
            } elseif ($xmydownloads_uploadselect == 0 && $nrows == 1) {  // Disable and there is a record
                COM_errorLog('Removing Logged-In users upload privilage with filemgmt.user feature',1);
                DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_grp_id = 13 AND acc_ft_id = $feature2_id");
            }
        }            
        if ($xmydownloads_uploadpublic != $mydownloads_uploadpublic ) {
            $result = DB_query("SELECT COUNT(*) FROM {$_TABLES['access']} WHERE acc_ft_id = $feature2_id AND acc_grp_id = 2");
            list($nrows) = DB_fetchArray($result);
            if ($xmydownloads_uploadpublic == 1 && $nrows == 0) {   // Enable and there is no record now
                COM_errorLog('Granting anonymous upload privilage to filemgmt.user feature',1);
                DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feature2_id, 2)");
            } elseif ($xmydownloads_uploadpublic == 0 && $nrows == 1) {  // Disable and there is a record
                COM_errorLog('Removing anonymous upload privilage with filemgmt.user feature',1);
                DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_grp_id = 2 AND acc_ft_id = $feature2_id");
            }
        }    

        $file = fopen($configfile, "w");
        $content = "";
        $content .= "<?php\n";
        $content .= "\n";
        $content .= "\$mydownloads_popular      = $xmydownloads_popular;\n";
        $content .= "\$mydownloads_newdownloads = $xmydownloads_newdownloads;\n";
        $content .= "\$mydownloads_perpage      = $xmydownloads_perpage;\n";
        $content .= "\$mydownloads_trimdesc     = $xmydownloads_trimdesc;\n";
        $content .= "\$mydownloads_whatsnew     = $xmydownloads_whatsnew;\n";
        $content .= "\$mydownloads_dlreport     = $xmydownloads_dlreport;\n";
        $content .= "\$mydownloads_selectpriv   = $xmydownloads_selectpriv;\n";
        $content .= "\$mydownloads_publicpriv   = $xmydownloads_publicpriv;\n";
        $content .= "\$mydownloads_uploadselect = $xmydownloads_uploadselect;\n";
        $content .= "\$mydownloads_uploadpublic = $xmydownloads_uploadpublic;\n";
        $content .= "\$mydownloads_useshots     = $xmydownloads_useshots;\n";
        $content .= "\$mydownloads_shotwidth    = $xmydownloads_shotwidth;\n";
        $content .= "\$filemgmt_Emailoption     = $my_emailoption;\n";
        $content .= "\$filemgmt_FileStore        = \"$my_filestore\";\n";
        $content .= "\$filemgmt_SnapStore        = \"$my_snapstore\";\n";
        $content .= "\$filemgmt_SnapCat          = \"$my_snapcat\";\n";
        $content .= "\$filemgmt_FileStoreURL     = \"$my_filestoreurl\";\n";
        $content .= "\$filemgmt_FileSnapURL      = \"$my_filesnapurl\";\n";
        $content .= "\$filemgmt_SnapCatURL       = \"$my_snapcaturl\";\n";
        $content .= "\n";
        $content .= "?>\n";

        fwrite($file, $content);
        fclose($file);
        redirect_header("{$_CONF['site_admin_url']}/plugins/filemgmt/index.php",2,_MD_CONFIGUPDATED);
        exit();
}

function uploadNewFile($newfile,$directory) {
    global $myts,$eh, $filemgmtDuplicatesAllowed, $filemgmtFilePermissions;
    if ($newfile["name"]!="") { 
        $name = $newfile['name'];        // this is the real name of your file
        $tmp  = $newfile['tmp_name'];    // temporary name of file in temporary directory on server
        $name = $myts->makeTboxData4Save($name);
        $logourl = rawurlencode($name);
        COM_errorLOG("AddNewFileShot - Upload filename  is " .$directory.$myts->makeTboxData4Save($name));
        if (is_uploaded_file ($tmp)) {             // is this temporary file really uploaded?
            $newfile = $directory.$name;
            if(!file_exists($newfile)) {   // Check to see the snapfile already exists
                $returnMove = move_uploaded_file($tmp, $newfile);    // move temp file to upload directory
                if (!$returnMove) {
                    COM_errorLOG("Filemgmt File add by admin error: New file could not be created: ".$tmp." to ".$name);
                    $eh->show("1106");
                    return false;
                } else {
                    $chown =@chmod ($newfile,$filemgmtFilePermissions);
                    COM_errorLOG("File uploaded and moved ok");
                    return true;
                }
            } else { 
                // Allow duplicate file names, user may want to have two filelisting to same file or has already copied the files manually
                COM_errorLOG("Filemgmt - Warning: Added new filelisting for a file that already exists ". $directory.$name);
                if (!$filemgmtDuplicatesAllowed) {
                    $eh->show("1108");
                    return false;
                } else {
                   return true;
                }
            }
        } else {
            COM_errorLOG("Filemgmt upload error: Temporary file does not exist: '".$tmp ."'");
            $eh->show("1107");
            return false;
        }  
    }
    return false;
}



function filemgmt_comments($firstcomment) {
    global $_USER,$_CONF,$HTTP_GET_VARS;
    $comment_id  = "filemgmt-".$HTTP_GET_VARS['lid'];
    $file = $HTTP_GET_VARS['filename'];
    if ($firstcomment) {
        $story=$comment_id;
        $pid=0;
        $type="filemgmt";
        echo COM_refresh($_CONF['site_url'] . "/comment.php?sid=$story&amp;pid=$pid&amp;type=$type");
    } else {
        $display = COM_siteHeader() . COM_userComments($comment_id,$file,'filemgmt','','nested');
        $display .= COM_siteFooter();
    } 
    echo $display;
    exit();

}

function filemgmt_error($errormsg) {
    $display .= COM_startBlock("<b>"._MD_ADMINTITLE."</b>");
    $display .= $errormsg;
    $display .= COM_endBlock();
    echo $display;
    exit();
}

switch ($op) {
        default:
            mydownloads();
            break;
        case "comment":
            filemgmt_comments($firstcomment);
            break;
        case "delNewDownload":
            delNewDownload();
            break;
        case "addCat":
            addCat();
            break;
        case "addSubCat":
            addSubCat();
            break;
        case "addDownload":
            addDownload();
            break;
        case "listBrokenDownloads":
            listBrokenDownloads();
            break;
        case "delBrokenDownloads":
            delBrokenDownloads();
            break;
        case "ignoreBrokenDownloads":
            ignoreBrokenDownloads();
            break;
        case "approve":
            approve();
            break;
        case "delVote":
            delVote();
            break;
        case "delCat":
            delCat();
            break;
        case "modCat":
            modCat();
            break;
        case "modCatS":
            modCatS();
            break;
        case "modDownload":
            modDownload();
            break;
        case "modDownloadS":
            modDownloadS();
            break;
        case "delDownload":
            delDownload();
            break;
        case "filemgmtConfigAdmin":
            filemgmtConfigAdmin();
            break;
        case "filemgmtConfigChange":
            filemgmtConfigChange();
            break;
        case "categoryConfigAdmin":
            categoryConfigAdmin();
            break;
        case "newfileConfigAdmin":
              newfileConfigAdmin();
            break;
        case "listNewDownloads":
            listNewDownloads();
            break;
}
?>