<?php
// ------------------------------------------------------------------------- //
//                Geeklog - PHP Content Management System                    //
// ------------------------------------------------------------------------- //
// Based on:                                                                 //
// myPHPNUKE Web Portal System - http://myphpnuke.com/                       //
// PHP-NUKE Web Portal System - http://phpnuke.org/                          //
// Thatware - http://thatware.org/                                           //
// ------------------------------------------------------------------------- //
// Developed for Geeklog as File Management Module                           //
// By: Blaine Lang  -  July 2002                                             //
// blaine@portalparts.com                                                     //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //


require_once('../lib-common.php');
include_once($_CONF[path_html]."filemgmt/include/header.php");
include_once($_CONF[path_html]."filemgmt/include/xoopstree.php");
include_once($_CONF[path_html]."filemgmt/include/textsanitizer.php");

$myts = new MyTextSanitizer;
$mytree = new XoopsTree($_DB_name,$_FM_TABLES['filemgmt_cat'],"cid","pid");

$page = filemgmtApplyFilter($HTTP_GET_VARS['page'],true);
$cid  = filemgmtApplyFilter($HTTP_GET_VARS['cid'],true);
$orderby  = filemgmtApplyFilter($HTTP_GET_VARS['orderby'],false);

if ($cid == 0 OR DB_count($_FM_TABLES['filemgmt_cat'],"cid","$cid") == 0) {
    echo COM_refresh($_CONF['site_url'] . '/filemgmt/index.php');
    exit;
}

$trimDescription=true;    // Set to false if you do not want to auto trim the description and insert the <more..> link 

$display  = COM_siteHeader('menu');
$display .= COM_startBlock("<b>"._MD_CATEGORYTITLE."</b>");
$display .= '<table width="100%" table border="0" cellspacing="0" cellpadding="3"><tr>' . LB ."<br><br>";


if (!isset($page) OR $page == 0) {
    // If no page sent then assume the first.
    $page = 1;
}
$show = $mydownloads_perpage;
$offset = ($page - 1) * $show;

if(isset($orderby) AND $orderby != "") {
    $orderby = convertorderbyin($orderby);
} else {
    $orderby = "date DESC";
}
$orderbyTrans = convertorderbytrans($orderby);
$sortmenu  = "<br /><small><center>"._MD_SORTBY."&nbsp;&nbsp;"._MD_TITLE;
$sortmenu .= " (<a href='viewcat.php?cid=$cid&orderby=titleA'><img src='images/up.gif' border='0' align='middle' alt='' /></a>";
$sortmenu .= "<a href='viewcat.php?cid=$cid&orderby=titleD'><img src='images/down.gif' border='0' align='middle' alt='' /></a>)"._MD_DATE;
$sortmenu .= " (<a href='viewcat.php?cid=$cid&orderby=dateA'><img src='images/up.gif' border='0' align='middle' alt='' /></a>";
$sortmenu .= "<a href='viewcat.php?cid=$cid&orderby=dateD'><img src='images/down.gif' border='0' align='middle' alt='' /></a>)"._MD_RATING;
$sortmenu .= " (<a href='viewcat.php?cid=$cid&orderby=ratingA'><img src='images/up.gif' border='0' align='middle' alt='' /></a>";
$sortmenu .= "<a href=viewcat.php?cid=$cid&orderby=ratingD><img src='images/down.gif' border='0' align='middle' alt='' /></a>)"._MD_POPULARITY;
$sortmenu .= " (<a href='viewcat.php?cid=$cid&orderby=hitsA'><img src='images/up.gif' border='0' align='middle' alt='' /></a>";
$sortmenu .= "<a href='viewcat.php?cid=$cid&orderby=hitsD'><img src='images/down.gif' border='0' align='middle' alt='' /></a>)";
$sortmenu .= "<br /><b><small>";
$sortmenu .= _MD_CURSORTBY .$orderbyTrans;
$sortmenu .= "</small></b><br /><br /></center>";

$display .= "<table width='100%' cellspacing='0' cellpadding='0' border='0'><tr><td align='center'>\n";
$display .= "<table width='100%' cellspacing='1' cellpadding='2' border='0' class='filemgmtbg3'><tr><td>\n";
$pathstring = "<a href='index.php'>"._MD_MAIN."</a>&nbsp;:&nbsp;";
$nicepath = $mytree->getNicePathFromId($cid, "title", "viewcat.php?op=");
$pathstring .= $nicepath;
$display .= "<b>".$pathstring."</b>";
$display .= "</td></tr></table>";

// get child category objects
$arr=array();
$arr=$mytree->getFirstChild($cid, "title");
if ( count($arr) > 0 ){
    $display .= "</td></tr>";
    $display .= "<tr><td align='left'><h4>"._MD_CATEGORIES."</h4></td></tr>\n";
    $display .= "<tr><td align='center'>";
    $scount = 0;
        $display .= "<table width='90%'><tr>";
        
        foreach($arr as $ele){
            $title = $myts->makeTboxData4Show($ele['title']);
            $totaldownload = getTotalItems($ele['cid'], 1);
            if ($ele['imgurl']==''){
            $display .= "<td align='left'><table border='0'><tr><td></td><td><b><a href=viewcat.php?cid=".$ele['cid'].">".$title."</a></b>&nbsp;(".$totaldownload.")&nbsp;&nbsp;</td></tr></table></td>";
            }else{
   //Changed Following Line to enable Hack for protected Store (Mthomas@shindengen.com)
               $display .= "<td align='left'><table border='0'><tr><td><img src='{$_CONF[site_url]}/filemgmt/visit.php?Mode=CategorySnaps&url={$ele['imgurl']}'></td><td><b><a href=viewcat.php?cid=".$ele['cid'].">".$title."</a></b>&nbsp;(".$totaldownload.")&nbsp;&nbsp;</td></tr></table></td>";
   //End Change
            }
               $scount++;
            if ( $scount == 4 ) {
                 $display .= "</tr><tr>";
                   $scount = 0;
           }
        }
   $display .= "</tr></table><br />\n";
   $display .= "<hr />";
}

$fullcountresult=DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE cid=$cid AND status>0");
list($maxrows) = DB_fetchArray($fullcountresult);
$numpages = ceil($maxrows / $show);

if($maxrows>0){
      $result = DB_query("SELECT d.lid, d.cid, title, url, homepage, version, size, submitter, logourl, status, date, hits, rating, votes, comments, description FROM {$_FM_TABLES['filemgmt_filedetail']} d, {$_FM_TABLES['filemgmt_filedesc']} t WHERE d.cid=$cid AND d.status>0 AND d.lid=t.lid ORDER BY {$orderby} LIMIT $offset, $show");

    $numrows = DB_numROWS($result);
    //if 2 or more items in result, show the sort menu
    if($maxrows>1){
        $display .= $sortmenu;
    }
    $display .= "<table width='100%' cellspacing=0 cellpadding=10 border=0>";
    
    for ($x =1; $x <=$numrows; $x++) {
        list($lid, $cid, $dtitle, $url, $homepage, $version, $size, $submitter, $logourl, $status, $time, $hits, $rating, $votes, $comments, $description)=DB_fetchArray($result);
        $rating = number_format($rating, 2);
        $dtitle = $myts->makeTboxData4Show($dtitle);
        $url = $myts->makeTboxData4Show($url);
        $url = urldecode($url);
        $homepage = $myts->makeTboxData4Show($homepage);
        $version = $myts->makeTboxData4Show($version);
        $size = $myts->makeTboxData4Show($size);
        $platform = $myts->makeTboxData4Show($platform);
        $logourl = $myts->makeTboxData4Show($logourl);
        $datetime = formatTimestamp($time);
        $description = $myts->makeTareaData4Show($description,0);
        $result2 = DB_query("SELECT username,photo  FROM {$_TABLES['users']} WHERE uid = $submitter");
        list ($submitter_name,$photo) = DB_fetchARRAY($result2);
        include($_CONF[path_html] ."filemgmt/include/dlformat.php");
    }
    $display .= "</table>";
    // Print Google-like paging navigation
    $base_url = $_CONF['site_url'] . '/filemgmt/viewcat.php?cid='.$cid.'&orderby='.$orderby;
    $display .= COM_printPageNavigation($base_url,$page, $numpages);
    
}    
$display .= "</td></tr></table>\n";
$display .= COM_endBlock();
$display .= COM_siteFooter();
echo $display;

?>