<?php
// ------------------------------------------------------------------------- //
//                Geeklog - PHP Content Management System                    //
// ------------------------------------------------------------------------- //
// Based on:                                                                 //
// myPHPNUKE Web Portal System - http://myphpnuke.com/                       //
// PHP-NUKE Web Portal System - http://phpnuke.org/                          //
// Thatware - http://thatware.org/                                           //
// ------------------------------------------------------------------------- //
// Developed for Geeklog as File Management Module                           //
// By: Blaine Lang  -  July 2002                                             //
// blaine@portalparts.com                                                     //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //


require_once('../lib-common.php');
include_once($_CONF[path_html]."filemgmt/include/header.php");
//Added by Mthomas for Protected Store Hack
include('dl_file.inc');

if (!SEC_hasRights("filemgmt.user")) {
    COM_errorLOG("Visit.php => FileMgmt Plugin Access denied. Attempted download of file ID: ".$lid.", Remote address is: ".$REMOTE_ADDR);
    redirect_header($_CONF['site_url']."/index.php",1,_GL_ERRORNOACCESS);
    exit();
}

if (isset($_USER['uid'])) {
    $uid = $_USER['uid'];
} else {
    $uid = 1;    // Set to annonymous GL User ID
}
//Addition by Mthomas to enable Protected Store Hack
switch ($_GET['Mode']){
case 'FileSnaps':
$path= $filemgmt_SnapStore.$url;
dl_file($path, 'View');
COM_accessLOG("Visit.php => ScreenShot Viewed: ".$url.", User ID is: ".$uid. ", Remote address is: ".$REMOTE_ADDR);
break;
case 'CategorySnaps';
$path= $filemgmt_SnapCat.$url;
dl_file($path, 'Download');
break;
Default:

//End Addition by Mthomas to enable Protected Store Hack

$lid = filemgmtApplyFilter($HTTP_GET_VARS['lid'],true);
if (DB_count($_FM_TABLES['filemgmt_filedetail'],"lid",$lid ) == 0) {
    COM_errorLOG("filemgmt visit.php ERROR: Attempt to download a file that is not on record. File ID: $lid");
    echo COM_refresh($_CONF['site_url'] . '/filemgmt/index.php');
    exit;
} else {
    DB_query("INSERT INTO {$_FM_TABLES['filemgmt_history']} (uid, lid, remote_ip, date) VALUES ($uid, $lid, '$REMOTE_ADDR', NOW())") or $eh->show("0013");
    DB_query("UPDATE {$_FM_TABLES['filemgmt_filedetail']} SET hits=hits+1 WHERE lid=$lid AND status>0");    
    $result = DB_query("SELECT url FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE lid=$lid AND status>0");
    list($url) = DB_fetchArray($result);
//Add/CHANGED by Mthomas to enable Protected Store Hack        
   $path = $filemgmt_FileStore.$url;

   //if(!$fdl=@fopen($path,'rb')){
   //die("Cannot Open File!");
   //} else {
     dl_file($path, 'Download');
     COM_accessLOG("Visit.php => Download File: ".$url.", User ID is: ".$uid. ", Remote address is: ".$REMOTE_ADDR);
}
}
//End Add/Change
?>